
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.geom.*;

/**
 * Created by IntelliJ IDEA.
 * User: unknown
 * Date: Oct 1, 2004
 * This is really page 76, using Graphics2D
 */
public class Transform2Dx extends JFrame {

    AffineTransform user2screen;
    AffineTransform screen2user;

    AffineTransform user;

    Timer timer;
    int count = 0; // number of times to setUpTimer animation
    double x = 40.0;
    double y = 75.0;
    double scale = 1.0;
    double rotate = 0.9;
    double xPixelsPerUser = 10;
    double yPixelsPerUser = 10;

    double xDisplayCenter = 400;
    double yDisplayCenter = 200;


    public Transform2Dx() {
        super("Transform2D.java");
        setUpGeometry();
        setUpTimer(1000);
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
        timer.start();
        setSize(20, 40);
        setVisible(true);
    }


    private void setUpGeometry() {
        user = new AffineTransform();
        System.out.println("user = " + user);
        user2screen = new AffineTransform();
        System.out.println("user2screen - new = " + user2screen );
        // Flip user y axis and scale:
        user2screen.scale(xPixelsPerUser, -yPixelsPerUser);
        System.out.println("user2screen - flip and scale = " + user2screen);
        // Move to center of frame
        user2screen.translate(xDisplayCenter/xPixelsPerUser, yDisplayCenter/yPixelsPerUser);
        System.out.println("user2screen - translate = " + user2screen);
        System.out.println("end of setUpGeometry");
    }

    private void setUpTimer(int milliseconds) {
        timer = new Timer(milliseconds, new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                count++;
                repaint();
                System.out.println("count = " + count);
                if (count == 3) {
                    timer.stop();
                }
            }
        });
    }

    public void paint(Graphics g) {
        drawOperations(g);
    }

    private void drawOperations(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;

        user.scale(scale, scale);
        System.out.println("user = " + user);
        user.rotate(rotate);
        // System.out.println("arrow.getBounds2D().toString()) = " + arrow.getBounds2D().toString());
        //  g2.setTransform(user2screen);
        x += 1;
        scale *= 0.9;
        rotate += Math.PI / 8.0;
        // }
    }


    public static void main(String[] args) {
        Transform2Dx t = new Transform2Dx();
        System.out.println("This is " + t.toString());
    }
}
